#include "connection_gtk.h"
#include "element_gtk.h"

#include <iostream>
#include <gtk/gtk.h>

using namespace Janus;
using std::cerr;
using std::endl;

ConnectionGtk::ConnectionGtk(const Parameters& p):
  Connection(p)
{
  
  ElementGtk* creator_ = dynamic_cast<ElementGtk*>(p.creator);
  ElementGtk* consumer_ = dynamic_cast<ElementGtk*>(p.consumer);

  if(creator_ && consumer_)
    {
      creator_->addReceiver(p.signal, consumer_, p.slot);
    }
  else
    {
      cerr << "ConnectionGtk: type of objects to be connected is no superclass of ElementGtk or id is not known !" 
	   << endl
	   << "                Cannot connect !" << endl;
    }
};

