#include "dialog.h"
#include <iostream>

using namespace Janus;
using std::cerr;
using std::endl;

Dialog::Dialog(const Parameters& param) :
  WidgetBase(param),
  accepted_(false)
{
  //create a modal dialog !
  //  widget_ = gtk_dialog_new ();
  widget_ = gtk_window_new (GTK_WINDOW_TOPLEVEL);
 
  gtk_widget_set_usize (GTK_WIDGET(widget_), width_, height_);

  gtk_window_set_title (GTK_WINDOW (widget_), 
			Element::getStringAttr("title","Janus gtk-binding").c_str());

  container_ = gtk_fixed_new();
  gtk_container_add(GTK_CONTAINER(widget_), container_);

  gtk_widget_show(container_);
}

Dialog::~Dialog()
{
  // gtk_widget_destroy(widget_);
}

Value 
Dialog::getValue(void) const
{
  return accepted_ ? "1" : "0";
}

void 
Dialog::call(const std::string& name, const Value& val)
{

  if(name == "execute")
    {
#ifndef NDEBUG
      cerr << "executing gtk::Dialog ... " << endl;
#endif
      accepted_ = false;
      WidgetBase::call("show");
      //   dialog->exec();
      /* All GTK applications must have a gtk_main(). Control ends here
       * and waits for an event to occur (like a key press or
       * mouse event). */
      gtk_main ();
  
#ifndef NDEBUG
      cerr << "returned from gtk::Dialog::exec(). Yuppee !" << endl;
#endif
    }
  else if(name == "accept")
    {
#ifndef NDEBUG
      cerr << "gtk::Dialog::accept() " << endl;
#endif
      accepted_ = true;
      gtk_main_quit();
      //dialog->accept();
    }
  else if(name == "reject")
    {
#ifndef NDEBUG
      cerr << "gtk::Dialog::reject() " << endl;
#endif
      gtk_main_quit();
      //dialog->reject();
    }
  else
    {
      WidgetBase::call(name, val);
    }
}
  

