#include "pushbutton.h"
#include <gtk/gtk.h>

#include <cstdio>
#include <iostream>

using namespace Janus;
using std::cerr;
using std::endl;

PushButton::PushButton(const Parameters& param) :
  WidgetBase(param)
{
  assert(parent_);

  std::string text = Element::getStringAttr("text").c_str();
  if(text.empty())
    widget_ = gtk_button_new ();  
  else
    widget_ = gtk_button_new_with_label (text.c_str());

  gtk_widget_set_usize (GTK_WIDGET(widget_), width_, height_);

  gtk_fixed_put (GTK_FIXED (parent_), widget_, x_, y_);
  
  gtk_widget_show(widget_);

  gtk_signal_connect(GTK_OBJECT(widget_),"clicked",
		     (GtkSignalFunc)&PushButton::slot_clicked, 
		     (gpointer)this);

}

PushButton::~PushButton()
{
  gtk_widget_destroy(widget_);
}
void 
PushButton::call(const std::string& name, const Value& val)
{
  WidgetBase::call(name, val);

  // dynamic_cast<uta::PushButton*> returns non-valid pointers !!!
  //  uta::PushButton* button = (uta::PushButton*)widget_;

}

void
PushButton::slot_clicked(GtkObject* from, gpointer callback_data )
{
#ifndef NDEBUG
  cerr << "reached ConnectionGtk::callback_func !"<<endl;
#endif
  PushButton* inst = (PushButton*)callback_data;

  char buffer[32];
  sprintf(buffer,"%d",inst->button_);
  inst->emit("clicked", buffer);
}
  

