#include "connection_sigc.h"
#include "element_sigc.h"
#include <iostream>

using std::cerr;
using std::endl;

using namespace Janus;
 
ConnectionSigC::ConnectionSigC(const Parameters& p):
  Connection(p),
  signalName_(p.signal),
  slotName_(p.slot)
{
  
  ElementSigC* creatorObj = dynamic_cast<ElementSigC*>(p.creator);
  ElementSigC* consumerObj = dynamic_cast<ElementSigC*>(p.consumer);

  if(creatorObj && consumerObj)
    {
      creatorObj->event.connect(SigC::slot(this, &ConnectionSigC::_slot));
      this->_signal.connect(SigC::slot(consumerObj, &ElementSigC::call));
    }
  else
    {
      cerr << "Janus::uta::ConnectionSigC: type of objects to be connected is no superclass of ElementSigC or id is not known !" 
	   << endl
	   << "                Cannot connect !" << endl;
    }
};


void 
ConnectionSigC::_slot(const std::string& name, const Value& val)
{
  if(name == signalName_)
    _signal.emit(slotName_, val);
}
