#include "font.h"
#include <uta/resources.h>

using namespace Janus;

Font::Font(const Parameters& param) :
  Element(param)
{
  std::string data = Element::getStringAttr("data","");
  id_ = Element::getStringAttr("id","");
#ifndef NDEBUG
  std::cerr << "Janus::Libuta::Font id="<<id_<<" source="<<data<<std::endl;
#endif

  if(!data.empty() && !id_.empty())
    {
      uta::Resources::instance->registerFont(id_,data);
    }
  else
    {
      std::cerr << "Janus::Libuta::Font failed to create resource " << id_ << std::endl;
    }
}

Font::~Font()
{
//   cerr << "Janus::Libuta::Font freeing resource " << id_ << endl;
//   uta::Resources::instance->unregister(id_);
} 
