#include "checkbox.h"
#include "color.h"
#include "connection_sigc.h"
#include "dialog.h"
#include "drawable.h"
#include "element_sigc.h"
#include "font.h"
#include "image.h"
#include "label.h"
#include "lineedit.h"
#include "listbox.h"
#include "pushbutton.h"
#include "slider.h"
#include "toolkit.h"
#include "widgetbase.h"
#include "widget.h"

namespace Janus {

void init_libuta()
{
    new Element::Factory<CheckBox>("CheckBox");
    new Element::Factory<Color>("Color");
    new Connection::Factory<ConnectionSigC>("connection_sigc++");  
    new Element::Factory<Dialog>("Dialog");
    new Element::Factory<Drawable>("Drawable");
    new Element::Factory<Font>("Font");
    new Element::Factory<Image>("Image");
    new Element::Factory<Label>("Label");
    new Element::Factory<LineEdit>("LineEdit");
    new Element::Factory<ListBox>("ListBox");
    new Element::Factory<PushButton>("PushButton");
    new Element::Factory<Slider>("Slider");
    new Element::Factory<Toolkit>("Toolkit");
    new Element::Factory<Widget>("Widget");
}

} // namespace Janus
