//  The Worldforge Project
//  Copyright (C) 1998, 1999 The Worldforge Project
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//
//  For information about Worldforge and its authors, please contact
//  the Worldforge Web Site at http://www.worldforge.org.
//
// created by Karsten Laux 11/2000

#ifndef _LABEL_H_
#define _LABEL_H_

#include <uta/terminal.h>
#include <uta/slider.h>

#include "widgetbase.h"
namespace Janus {

/** Label class.
 */
class Label : public WidgetBase
{
  friend class Element::Factory<Label>;  

 public: 
  /** Destructor.
  */
  virtual ~Label();
  
  /** call named method.
   */
  virtual void call(const std::string& name, const Value& = VALUE_NONE);
  ///
  virtual Value getValue(void) const;

 protected:
  /** Constructor.
  */
  Label(const Parameters& param); 
  ///
  void slot_terminal();
  ///
  void slot_scrollUp();  
  ///
  void slot_scrollDown();
  ///
  void slot_link(unsigned);
  ///
  uta::Terminal* terminal_;
  ///
  uta::Slider* slider_;
  ///
  int step_;
  ///
  std::string lastLink_;
};


} // namespace Janus

#endif
  
